<template>
    <client-only>
        <cdx-dialog
            v-model:open="open"
            :title="dialogTitle"
            close-button-label="Close"
            :primary-action="primaryAction"
            :default-action="defaultAction"
            @primary="onPrimaryAction"
            @default="onDefaultAction"
      @update:open="onDefaultAction"
        >
      <p>{{ dialogText }}</p>
        </cdx-dialog>
    </client-only>
</template>

<script setup>
import { ref } from 'vue'
import { CdxDialog } from '@wikimedia/codex'
import { toast } from 'vue3-toastify';
import 'vue3-toastify/dist/index.css';
import { useCookies} from 'vue3-cookies';
import { useInstrumentStore } from '../../stores/instrument.js'

const { cookies } = useCookies();
const store = useInstrumentStore();

const open = ref( true )
const emit = defineEmits("[dialog-event]")
const closeDialog = () => emit("dialog-event");

// Customize text and title according to the action that will be done (activate or deactivate the instrument)
let action = 'activate'
let turn = 'on'
if (store.instrument.status) {
    action = 'deactivate';
    turn = 'off';
}
const type = store.isABTest ? 'A/B test' : 'instrument';
const dialogTitle = `Are you sure you want to turn this ${type} ${turn}?`;
const afterActivationMessage = store.isABTest ?
    "the experiment's name, feature variants, and sampling configuration will no longer be editable." :
    "the instrument's name will no longer be editable.";
const dialogOnText = `Activating the ${type} "${store.instrument.name}" will enable data collection on ${store.instrument.utc_start_dt.split('T')[0]}, provided instrumentation code has been deployed to production. After activation, ${afterActivationMessage}`;
const dialogOffText = `Deactivating the ${type} "${store.instrument.name}" will stop data collection`;
const dialogText = turn === 'on' ? dialogOnText : dialogOffText;

const primaryAction = {
  label: action.charAt(0).toUpperCase() + action.slice(1),
  actionType: 'progressive'
};

const defaultAction = {
  label: 'Cancel',
};

function onDefaultAction() {
  open.value = false
  closeDialog()
}

async function onPrimaryAction() {
  open.value = false

  const data = Object.assign({
      csrf_token: cookies.get('csrf_token'),
      id: store.instrument.id,
      name: store.instrument.name,
      status: !store.instrument.status
  });

  const response = await store.patchInstrumentStatus(data);
  toast(response.data.title, {
    type: response.success ? 'success' : 'error',
    position: 'bottom-right',
    autoClose: 100,
    pauseOnFocusLoss: false,
    hideProgressBar: true,
    ...response.success && { onClose: () => location.reload()}
  });

  if (!response.success) {
    closeDialog()
  }
}
</script>
